# groot
Java Data Visualization project designed to make histogramming, plotting, and fitting accessible for Java users. 
## Features
- Histograms 1D/2D
- Functions 
- GraphErrors 
- Fitting routines using Minuit
- GUI tools for easily editing plot attributes and for fitting

# Examples
Try out the [demo jar](https://github.com/gavalian/groot/raw/master/jars/GrootDemo.jar) and check out the examples on our [Wiki](https://github.com/gavalian/groot/wiki "GROOT Wiki"). 
To run the example: Simply double click on the jar if you're a mac user, or if you're a linux user run ```java -jar GrootDemo.jar```

<img src="https://github.com/gavalian/groot/blob/master/images/multipad.png" width="800">
<img src="https://github.com/gavalian/groot/blob/master/images/histogram2d_demo.png" width="400">
<img src="https://github.com/gavalian/groot/blob/master/images/copyPaste.png" width="400">
<img src="https://github.com/gavalian/groot/blob/master/images/totalcs_ppbar.png" width="800">

# groot 4
groot is getting an updated plotting package. Many improvements with plotting and new features.
This version (version=4) has many improvements allowing to produce article and presentation 
ready figures, supports PDF and SVG output.

<img src="https://github.com/gavalian/groot/blob/master/images/groot4_example_1.png" width="800">

In new version there are few new graph types, commonly used in analysis. Here is an example of Bar graph.

<img src="https://github.com/gavalian/groot/blob/master/images/bar_graph_example.png" width="800">

New canvas styles are imeplemented with preset configuration for plotting related plots.

<img src="https://github.com/gavalian/groot/blob/master/images/multiplot_example.png" width="800">

# Installation
Simply add this [library jar](https://github.com/gavalian/groot/raw/master/jars/) to your build path in an IDE.

# Requirements
Java 1.8 or greater

# Documentation
Check out our [Wiki](https://github.com/gavalian/groot/wiki "GROOT Wiki")!

# Feature requests and contributions
One of the best ways to contribute is to give us feature requests and bug reports on the [issues page](https://github.com/gavalian/groot/issues "GROOT Issues page")! 
